package com.fullertonindia.flutter_demo_lib;

import android.annotation.TargetApi;
import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.os.Build;
import android.util.Base64;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.security.Key;
import java.security.KeyFactory;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.Provider;
import java.security.PublicKey;
import java.security.Security;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;

import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;


public class GatewayUtils {

    @TargetApi(Build.VERSION_CODES.FROYO)
    public static String generateAESKEY() throws NoSuchAlgorithmException {
        KeyGenerator keyGen = KeyGenerator.getInstance("AES");
        keyGen.init(256); // for example
        SecretKey secretKey = keyGen.generateKey();

        byte[] encrypted = secretKey.getEncoded();
        String key = Base64.encodeToString(encrypted, Base64.DEFAULT);
        return key;
    }

    public static String getAESDecryptString(String encryptedStr, String secretKeyStr) {
        try {
            MessageDigest md = MessageDigest.getInstance("md5");
            byte[] digestOfPassword = md.digest(secretKeyStr.getBytes("UTF-8"));

            SecretKeySpec skeySpec = new SecretKeySpec(digestOfPassword, "AES");
            Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
            cipher.init(Cipher.DECRYPT_MODE, skeySpec);
            byte[] decrypted = cipher.doFinal(Base64.decode(encryptedStr.getBytes("UTF-8"), Base64.DEFAULT));
            return new String(decrypted, "UTF-8");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    @TargetApi(Build.VERSION_CODES.DONUT)
    public static String getApkName(Context context) {
        ApplicationInfo applicationInfo = context.getApplicationInfo();
        int stringId = applicationInfo.labelRes;
        return stringId == 0 ? applicationInfo.nonLocalizedLabel.toString() : context.getString(stringId).replace(" ", "");

    }

    public static String getAESEncryptString(String originalText, String secretKeyStr) {
        try {
            MessageDigest md = MessageDigest.getInstance("md5");
            byte[] digestOfPassword = md.digest(secretKeyStr.getBytes("UTF-8"));
            SecretKeySpec skeySpec = new SecretKeySpec(digestOfPassword, "AES");
            Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
            cipher.init(Cipher.ENCRYPT_MODE, skeySpec);
            byte[] encrypted = cipher.doFinal(originalText.getBytes("UTF-8"));
            return Base64.encodeToString(encrypted, Base64.DEFAULT);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    @TargetApi(Build.VERSION_CODES.FROYO)
    public static String getRSADecryptString(String encryptedStr, String privateKeyStr) {
        String decoded = "";

        try {

            KeyFactory keyFactory = KeyFactory.getInstance("RSA");

            PKCS8EncodedKeySpec privSpec = new PKCS8EncodedKeySpec(Base64.decode(privateKeyStr.getBytes("UTF-8"), Base64.DEFAULT));// strPrivateKey is the asymmetric private key stored in server database

            Key decryptionKey = keyFactory.generatePrivate(privSpec);


            byte[] enc_str_byte = Base64.decode(encryptedStr.getBytes("UTF-8"), Base64.DEFAULT);

            Provider p;
            Cipher rsa;


            rsa = Cipher.getInstance("RSA/ECB/PKCS1Padding");//RSA/ECB/PKCS1Padding
            rsa.init(Cipher.DECRYPT_MODE, decryptionKey);

            byte[] dec_str_bytes = rsa.doFinal(enc_str_byte);
            decoded = new String(dec_str_bytes, "UTF-8");


            return decoded;

        } catch (Exception e) {

            e.printStackTrace();

            StringWriter sw = new StringWriter();

            PrintWriter pw = new PrintWriter(sw);

            e.printStackTrace(pw);
            return null;

        }


    }


    @TargetApi(Build.VERSION_CODES.FROYO)
    public static String getRSAEncryptString(String originalText, String publicKeyStr) {
        try {
            byte[] symm_iv_bytes = originalText.getBytes("UTF-8");

            byte[] keyBytes = Base64.decode(publicKeyStr.getBytes(), Base64.DEFAULT);
            X509EncodedKeySpec publicKeySpec = new X509EncodedKeySpec(keyBytes);
            KeyFactory kf = KeyFactory.getInstance("RSA");
            PublicKey pkPublic = kf.generatePublic(publicKeySpec);
            // Cipher pkCipher = Cipher.getInstance("RSA");
            Provider p;
            Cipher rsa;
            p = Security.getProvider("BC");
            rsa = Cipher.getInstance("RSA/ECB/PKCS1Padding", p);
            // RSA/ECB/PKCS1Padding
            rsa.init(Cipher.ENCRYPT_MODE, pkPublic);
            byte[] encryptedInByte = rsa.doFinal(symm_iv_bytes);
            String encryptedParam = new String(Base64.encode(encryptedInByte, Base64.DEFAULT));
            return encryptedParam;
        } catch (Exception e) {
            e.printStackTrace();
            StringWriter sw = new StringWriter();
            PrintWriter pw = new PrintWriter(sw);
            e.printStackTrace(pw);
            return null;
        }
    }
}

