import 'dart:async';

import 'package:flutter/services.dart';

class FlutterDemoLib {
  static const MethodChannel _channel = const MethodChannel('flutter_demo_lib');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String> get showAlertDialog async {
    return _channel.invokeMethod('showAlertDialog');
  }

  static Future<List<dynamic>> callFDSAndGetImages(String method,
      [dynamic param]) async {
    try {
      final List<dynamic> result = await _channel.invokeMethod(method, param);
      return result;
    } on PlatformException catch (e) {
      print(e.message);
    } //{"param": param}
  }

  static Future<String> getNativeCodeLogic(String method,
      [dynamic param]) async {
    try {
      final String result = await _channel.invokeMethod(method, param);
      return result;
    } on PlatformException catch (e) {
      print(e.message);
    } //{"param": param}
  }
}
